=== debian/changelog ===
level-zero-gpu-raytracing (1.0.0-0ubuntu1) plucky; urgency=medium

  * Upload to plucky (LP: #2096898)
    - d/copyright: Amended.

 -- Shane McKee <shane.mckee@canonical.com>  Thu, 27 Feb 2025 12:15:25 +0800

level-zero-gpu-raytracing (1.0.0-1) unstable; urgency=medium

  * Initial packaging. (Closes: #1099036)

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 27 Feb 2025 18:13:10 +0200
