=== debian/control ===
Source: level-zero-gpu-raytracing
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libpthread-stubs0-dev,
 libtbb-dev,
 libze1,
 ninja-build,
 pkgconf,
Standards-Version: 4.7.2
Homepage: https://github.com/intel/level-zero-raytracing-support
Vcs-Browser: https://salsa.debian.org/debian/level-zero-gpu-raytracing
Vcs-Git: https://salsa.debian.org/debian/level-zero-gpu-raytracing.git

Package: libze-intel-gpu-raytracing
Replaces: intel-level-zero-gpu-raytracing
Conflicts: intel-level-zero-gpu-raytracing
Architecture: amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Level Zero Ray Tracing Support library
 The Level Zero Ray Tracing Support library implements high performance CPU
 based construction algorithms for 3D acceleration structures that are
 compatible with the ray tracing hardware of Intel GPUs.
 .
 This library is used by Intel(R) oneAPI Level Zero to implement part of the
 RTAS builder extension.
 .
 This library should not get used directly but only through Level Zero.
