## level-zero-gpu-raytracing 1.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,9 +6,12 @@
 project(ze_raytracing)
 
 SET(ZE_RAYTRACING_VERSION_MAJOR 1)
-SET(ZE_RAYTRACING_VERSION_MINOR 0)
+SET(ZE_RAYTRACING_VERSION_MINOR 1)
 SET(ZE_RAYTRACING_VERSION_PATCH 0)
 SET(ZE_RAYTRACING_VERSION ${ZE_RAYTRACING_VERSION_MAJOR}.${ZE_RAYTRACING_VERSION_MINOR}.${ZE_RAYTRACING_VERSION_PATCH})
+IF (ZE_RAYTRACING_VERSION_BUILD)
+  SET(ZE_RAYTRACING_VERSION ${ZE_RAYTRACING_VERSION}.${ZE_RAYTRACING_VERSION_BUILD})
+ENDIF()
 
 IF(COMMAND cmake_policy)
   if(POLICY CMP0135)
@@ -26,7 +29,7 @@
 SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
 
 # Build configurations to use
-SET(CMAKE_BUILD_TYPE "ReleaseInternal" CACHE STRING "Specifies the build type." FORCE)
+SET(CMAKE_BUILD_TYPE "ReleaseInternal" CACHE STRING "Specifies the build type.")
 SET_PROPERTY(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS Debug Release ReleaseInternal)
 SET(CMAKE_CONFIGURATION_TYPES "Debug;Release;ReleaseInternal" CACHE STRING "List of generated configurations." FORCE)
 
@@ -112,6 +115,9 @@
   ADD_DEFINITIONS("-DEMBREE_SYCL_ALLOC_DISPATCH_GLOBALS")
 ENDIF()
 
+SET(ZE_RAYTRACING_SYCL_TESTS "OFF" CACHE STRING "Enable SYCL tests.")
+SET_PROPERTY(CACHE ZE_RAYTRACING_SYCL_TESTS PROPERTY STRINGS OFF DEFAULT_RTAS_BUILDER INTERNAL_RTAS_BUILDER LEVEL_ZERO_RTAS_BUILDER)
+
 STRING(TOLOWER "${CMAKE_CXX_COMPILER_ID}" LOWER_CXX_COMPILER_ID)
 include(${LOWER_CXX_COMPILER_ID})
 
@@ -124,11 +130,14 @@
   SET(EMBREE_RTHWIF_SYCL embree_rthwif_sycl)
 ENDIF()
 
+ADD_SUBDIRECTORY(rtbuild/sys)
+ADD_SUBDIRECTORY(rtbuild/simd)
 ADD_SUBDIRECTORY(level_zero)
-ADD_SUBDIRECTORY(rtbuild)
 
-SET(ZE_RAYTRACING_SYCL_TESTS "OFF" CACHE STRING "Enable SYCL tests.")
-SET_PROPERTY(CACHE ZE_RAYTRACING_SYCL_TESTS PROPERTY STRINGS OFF DEFAULT_RTAS_BUILDER INTERNAL_RTAS_BUILDER LEVEL_ZERO_RTAS_BUILDER)
+IF (NOT ZE_RAYTRACING_SYCL_TESTS STREQUAL "LEVEL_ZERO_RTAS_BUILDER") # do not build RTAS builder when building LEVEL_ZERO test
+  ADD_SUBDIRECTORY(rtbuild)
+ENDIF()
+
 IF (NOT ZE_RAYTRACING_SYCL_TESTS STREQUAL "OFF")
   ADD_SUBDIRECTORY(testing)
 ENDIF()
