=== rtbuild/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,5 @@
 ## Copyright 2009-2021 Intel Corporation
 ## SPDX-License-Identifier: Apache-2.0
-
-ADD_SUBDIRECTORY(sys)
-ADD_SUBDIRECTORY(simd)
 
 ADD_LIBRARY(embree_rthwif SHARED rtbuild.cpp qbvh6.cpp statistics.cpp ../level_zero_raytracing.rc)
 TARGET_LINK_LIBRARIES(embree_rthwif PUBLIC ${EMBREE_RTHWIF_SYCL} PRIVATE tbb simd sys)
