=== debian/changelog ===
level-zero-gpu-raytracing (1.1.0-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 12 Aug 2025 09:31:06 +0300
