=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --builddir build --buildsystem=cmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DZE_RAYTRACING_TBB_STATIC=OFF

override_dh_auto_clean:
	dh_auto_clean
	rm level_zero_raytracing.rc || true
