=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%level-zero-gpu-raytracing-$1.tar.gz%" \
   https://github.com/intel/level-zero-raytracing-support/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
